Subject: neighbour table RCU

From: Stephen Hemminger <[email-masked]>
Date: Mon, 31 Aug 2009 15:04:53 -0700

Looking at the neighbour table, it should be possible to get
rid of the two reader/writer locks.  The hash table lock is pretty
amenable to RCU, but the dynamic resizing makes it non-trivial.
Thinking of using a combination of RCU and sequence counts so that the
reader would just rescan if resize was in progress.

The reader/writer lock on the neighbour entry is more of a problem.
Probably would be simpler/faster to change it into a spinlock and
be done with it.

The reader/writer lock is also used for the proxy list hash table,
but that can just be a simple spinlock.

--